package org.switchyard.example.bpel;

import java.math.BigDecimal;

import org.switchyard.annotations.Transformer;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public final class AssessorTransformers {

	@Transformer(to = "{urn:org.switchyard.example:switchyard-bpel-example:risk-assessment:1.0}checkResponse")
	public String transformRiskLevelToCheckResponse(RiskLevel from) {
		return "<checkResponse xmlns='urn:org.switchyard.example:switchyard-bpel-example:risk-assessment:1.0'><level>"
				+ from.toString() + "</level></checkResponse>";
	}

	@Transformer(from = "{urn:org.switchyard.example:switchyard-bpel-example:risk-assessment:1.0}check")
	public LoanRequest transformCheckToLoanRequest(Element from) {
		final LoanRequest retVal = new LoanRequest();
		final NodeList nodes = from.getChildNodes();
		for (int index = 0, count = nodes.getLength(); index < count; ++index) {
			final Node node = nodes.item(index);
			final String nodeName = node.getLocalName();
			if (nodeName == null || node.getNodeType() != Node.ELEMENT_NODE) {
				continue;
			}
			if (nodeName.equals("name")) {
				retVal.setName(node.getTextContent());
			} else if (nodeName.equals("firstName")) {
				retVal.setFirstName(node.getTextContent());
			} else if (nodeName.equals("amount")) {
				try {
					retVal.setAmount(new BigDecimal(node.getTextContent()));
				} catch (Exception e) {
					retVal.setAmount(null);
				}
			}
		}
		return retVal;
	}

}
