package org.switchyard.example.bpel;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.switchyard.component.test.mixins.cdi.CDIMixIn;
import org.switchyard.test.Invoker;
import org.switchyard.test.ServiceOperation;
import org.switchyard.test.SwitchYardRunner;
import org.switchyard.test.SwitchYardTestCaseConfig;
import org.switchyard.test.SwitchYardTestKit;

@RunWith(SwitchYardRunner.class)
@SwitchYardTestCaseConfig(mixins = CDIMixIn.class, config = SwitchYardTestCaseConfig.SWITCHYARD_XML)
public class LoanServiceTest {

	@ServiceOperation("LoanService")
	private Invoker service;
	private SwitchYardTestKit _testKit;

	@Test
	public void testRequest() throws Exception {
		// initialize your test message
		Object message = _testKit.readResourceString("loan-request1.xml");
		String result = service.operation("request").sendInOut(message)
				.getContent(String.class);

		// validate the results
		SwitchYardTestKit.compareXMLToString(
				_testKit.readResourceString("loan-response1.xml"), result);

		// initialize your test message
		message = _testKit.readResourceString("loan-request2.xml");
		result = service.operation("request").sendInOut(message)
				.getContent(String.class);

		// validate the results
		SwitchYardTestKit.compareXMLToString(
				_testKit.readResourceString("loan-response2.xml"), result);

		// initialize your test message
		message = _testKit.readResourceString("loan-request3.xml");
		result = service.operation("request").sendInOut(message)
				.getContent(String.class);

		// validate the results
		SwitchYardTestKit.compareXMLToString(
				_testKit.readResourceString("loan-response3.xml"), result);
	}

}
